//----------------------------------------------------------------------
//  File    : ColorPickerDlg.cpp 
//  Project :
//  Author  : Patrick PRACHE (pprache@kalisto.com)
//  Created : september 10 1999
//----------------------------------------------------------------------
//  Purpose	: Example dialog   
//  Notes	: this dialog implement a PowerColorPicker (private joke)
//----------------------------------------------------------------------

#include "stdafx.h"
#include "PowerColorPicker.h"
#include "ColorPicker.h"
#include "ColorPickerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CColorPickerDlg dialog

CColorPickerDlg::CColorPickerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CColorPickerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CColorPickerDlg)
	m_r = 0;
	m_b = 0;
	m_g = 0;
	m_h = 0.0f;
	m_l = 0.0f;
	m_s = 0.0f;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CColorPickerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CColorPickerDlg)
	DDX_Text(pDX, IDC_R, m_r);
	DDV_MinMaxInt(pDX, m_r, 0, 255);
	DDX_Text(pDX, IDC_B, m_b);
	DDV_MinMaxInt(pDX, m_b, 0, 255);
	DDX_Text(pDX, IDC_G, m_g);
	DDV_MinMaxInt(pDX, m_g, 0, 255);
	DDX_Text(pDX, IDC_H, m_h);
	DDV_MinMaxDouble(pDX, m_h, 0.f, 1.f);
	DDX_Text(pDX, IDC_L, m_l);
	DDV_MinMaxDouble(pDX, m_l, 0., 1.);
	DDX_Text(pDX, IDC_S, m_s);
	DDV_MinMaxDouble(pDX, m_s, 0., 1.);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CColorPickerDlg, CDialog)
	//{{AFX_MSG_MAP(CColorPickerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_APPLYRGB, OnApplyrgb)
	ON_BN_CLICKED(IDC_APPLYHSL, OnApplyhsl)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()




void testfunc(COLORREF ref,void *ClientData)
{
	CColorPickerDlg * local= (CColorPickerDlg*)ClientData;
	
	/*char str[256];
	sprintf(str,"RED: %ld\nGREEN: %ld\nBLUE: %ld",GetRValue(ref),GetGValue(ref),GetBValue(ref));

	OutputDebugString(str);*/
	local->m_r = GetRValue(ref);
	local->m_g = GetGValue(ref);
	local->m_b = GetBValue(ref);

	double H,L,S;
	local->picker.GetHLS(&H,&L,&S);
	local->m_h = H;
	local->m_l = L;
	local->m_s = S;

	local->UpdateData(FALSE);
	//local->MessageBox(str);

}



/////////////////////////////////////////////////////////////////////////////
// CColorPickerDlg message handlers

BOOL CColorPickerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//
	// create color Picker
	//
//	RECT rect={0,0,100,100};
	RECT rect={10,10,390,300};
	
	picker.SetLuminanceBarWidth(20);

	picker.Create(NULL, 
				   "Haha", 
				   WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS , 
				   rect,  
				   this,
				   NULL,
				   NULL);

	picker.RegisterCallbackOnMove(testfunc,this);
	picker.RegisterCallbackOnLButtonDown(testfunc,this);

//	m_haha.SubclassWindow(picker.m_hWnd);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CColorPickerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{

		CDialog::OnPaint();
	}
}

HCURSOR CColorPickerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


int CColorPickerDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	return 0;
}

void CColorPickerDlg::OnApplyrgb() 
{
	UpdateData(TRUE);
	COLORREF ref= RGB(m_r,m_g,m_b);
	picker.SetRGB(ref);
}

void CColorPickerDlg::OnApplyhsl() 
{
	UpdateData(TRUE);
	picker.SetHLS(m_h,m_l,m_s);
}
