//----------------------------------------------------------------------
//  File    : PowerColorPicker.h 
//  Project :
//  Author  : Patrick PRACHE (pprache@kalisto.com)
//  Created : september 10 1999
//----------------------------------------------------------------------
//  Purpose	: this class defines a new type of color picker MFC control.   
//  Notes	: use this code as you want, it's free
//----------------------------------------------------------------------

#if !defined(AFX_POWERCOLORPICKER_H__D2BC4300_670F_11D3_8167_346906C10374__INCLUDED_)
#define AFX_POWERCOLORPICKER_H__D2BC4300_670F_11D3_8167_346906C10374__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// PowerColorPicker.h : header file
//
typedef void(*CallbackFunc)(COLORREF, void *ClientData);

/////////////////////////////////////////////////////////////////////////////
// PowerColorPicker window

class PowerColorPicker : public CWnd
{
// Construction
public:
	PowerColorPicker();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(PowerColorPicker)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~PowerColorPicker();
	virtual void RegisterCallbackOnMove(CallbackFunc ptr,void* ClientData){pOnMove = ptr;onMoveCD=ClientData;};
	virtual void RegisterCallbackOnLButtonDown(CallbackFunc ptr,void* ClientData){pOnLDown=ptr;onLDownCD=ClientData;};
	virtual void DrawCrossAt(CPoint &point,CPaintDC &dc,SIZE &sz);
	
	void		SetRGB(COLORREF ref);
	COLORREF	GetRGB();

	void SetHLS(double hue,double luminance, double saturation);
	void GetHLS(double *hue,double *luminance, double *saturation);

	void SetLuminanceBarWidth	(int w);
	void SetFinalColorHeight	(int h);
	
	// Generated message map functions
protected:
	//{{AFX_MSG(PowerColorPicker)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
    CDC *pickerDC;
    CDC *luminanceBarDC;

	BOOL pickerBmpState;
	BOOL luminanceBarState;

	CallbackFunc pOnMove;	// callback
	CallbackFunc pOnLDown;	// callback
	void * onMoveCD;		// client data
	void * onLDownCD;		// client data

	CPoint		mousePos;	// position of the picker
	int			moveMode;	// moving on picker or on luminance

	double		currentLuminance, currentSaturation, currentHue;
	COLORREF	currentColor;

	SIZE szColorPicker;
	SIZE szLuminanceBar;
	SIZE szTotal;

	BOOL createPickerDC;
	BOOL createLuminanceDC;
	
	int  width_of_luminance_bar;
	int  height_of_final_color;

	void GeneratePicker();
	void GenerateLuminanceBar();
	

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_POWERCOLORPICKER_H__D2BC4300_670F_11D3_8167_346906C10374__INCLUDED_)
